VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   900
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5985
   LinkTopic       =   "Form1"
   ScaleHeight     =   900
   ScaleWidth      =   5985
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "lsen"
      Height          =   315
      Left            =   4500
      TabIndex        =   1
      Top             =   300
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Text            =   "( (e * pi) ^ 0.5 - 10 + 0.0777176346777 ) / ---10"
      Top             =   300
      Width           =   3975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Private Sub Command1_Click()
    Dim clsExpr As Expression
    Set clsExpr = New Expression

    clsExpr.AddVariable "e", Exp(1)
    clsExpr.AddVariable "pi", Atn(1) * 4

    clsExpr.ExpressionString = Text1.Text

    If clsExpr.SolveExpression Then
        MsgBox Text1.Text & " = " & clsExpr.Result
    Else
        MsgBox "Fehler beim Parsen!"
    End If
End Sub

Private Sub Bench()
    Const fnc As String = "((2.71828*3.14159)^0.5-10+0.0777176346777) / -10"
    Const itr As Long = 10000
    
    Dim i As Long
    Dim d As Double
    
    '''''''''''''''''''''''''''''''''''''''''''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''
        
    Dim obj As Object
    Set obj = CreateObject("ScriptControl")
    
    obj.Language = "VBScript"
    obj.AddCode "sub main()" & vbCrLf & _
                    "x = " & fnc & vbCrLf & _
                "end sub"
    
    d = Timer
    For i = 1 To itr
        obj.run "main"
    Next
    MsgBox "ScriptCtrl: " & (Timer - d) * 1000 & " ms", , "Benchmark"
    
    '''''''''''''''''''''''''''''''''''''''''''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''
        
    Dim clsExpr As Expression
    Set clsExpr = New Expression
    
    clsExpr.ExpressionString = fnc
    
    d = Timer
    For i = 1 To itr
        clsExpr.SolveExpression
    Next
    MsgBox "Expression: " & (Timer - d) * 1000 & " ms", , "Benchmark"
    
    '''''''''''''''''''''''''''''''''''''''''''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''
    
    Set obj = Nothing
    Set clsExpr = Nothing
End Sub

Private Sub Form_Load()
    Bench
End Sub
